# Author: Claude Anderson:  November, 2008

class Vertex:
    "Represents a vertex in an adjacency list"
    def __init__(self, vertex):
        self.v = vertex
        self.adj = [] 
        
    def degree(self):
        return self.adj.len
    
    def get(self, i):
        """Get the ith vertex from this vertex's adjacency list.
           No error checking is done"""
        return self.adj[i]
    
    def add(self, v):
        """ Add a vertex to this vertex's adjacency list """
        self.adj.append(v)
        
    def getVertex(self):
        return self.v
    
    def __str__(self):
        result = str(self.v) + ": " + str(self.adj)  
        return result      
        


class AdjancencyListGraph:
    def __init__(self, adjlist):
        """ adjlist is a nested list representation of the graph """        self.vertexList = [v[0] for v in adjlist]
        self.adjacencyList = [Vertex(v) for v in self.vertexList]
        for v in adjlist:
            self.setVertex(v[0], v[1])
        
    def getList(self, v):
        for ver in self.adjacencyList:
            if ver.v == v:
                return ver.adj
        return None
    
    def length(self):
        return len(self.adjacencyList)
    
    def setVertex(self, v, vList):
        i = self.vertexList.index(v)
        for v in vList:
            if v[0] not in self.vertexList:
                print ("Illegal vertex in graph")
                exit()
            self.adjacencyList[i].add(v)
            
    def __str__(self):
        result = ""
        for a in self.adjacencyList:
            result += (str(a) + "\n")
        return result


if __name__ == "__main__":
    alg = AdjancencyListGraph(
            [['a', ['b','c']],
             ['b', ['a']],
             ['c', ['a']],
             ['d', []]])
    print (alg)

            
            
        
            
        
        