# Author: Claude Anderson:  November, 2008

from MinHeap import *
from AdjacencyLIstGraph import *


INFINITY = 1234567890
VERTEX = 0  # An edge is a list of two numbers:
WEIGHT = 1  # These are what the subscripts (0 and 1) mean.

def prim(adj, start):
    """ parent[v] = parent of v in MST rooted at start """
    n = adj.length()             # vertices in graph
    key = [None] + [INFINITY]*n  # later they will be decreased
    parent = [None] + [0]*n      # placeholders
    key[start] = 0
    parent[start] = 0
    heap = MinHeap(key)  # non-infinity value in heap represents fringe vertex
    for i in range(1, n+1):
        v = heap.delete()
        edges = adj.getList(v)  # all vertices adjacent to v
        for edge in edges:  # an edge is a list of: other vertex and weight
            w = edge[VERTEX] 
            if heap.isIn(w) and edge[WEIGHT] < heap.keyVal(w):
                parent[w] = v
                heap.decrease(w, edge[WEIGHT])
    return parent
    
def edgeListFromParentArray(parent):
    result = []
    for i in range(1, len(parent)):
        if parent[i] > 0:
            result.append([parent[i], i]) 
    return result
               
def main():
    g = AdjancencyListGraph(
            [[1, [(2, 4),(3, 2), (5, 3)]],
             [2, [(1, 4), (4, 5)]],
             [3, [(1, 2), (5, 6), (4, 1), (6,3)]],
             [4, [(2, 5), (6,6), (3,1)]],
             [5, [(1, 3), (3,6), (6,2)]],
             [6, [(5, 2), (3, 3), (4, 6)]]
             ])
    mst = prim(g, 5)
    print (mst)
    print (edgeListFromParentArray(mst))
    

main()